

class ControlPoints {
     float Ax, Ay, Bx, By, Strength; //input arguments
    
    //Constructor
    ControlPoints(float Ax, float Ay, float Bx, float By, float Strength){
      this.Ax = Ax;
      this.Ay = Ay;
      this.Bx = Bx;
      this.By = By;
      this.Strength = Strength;
    }
  
    //Methods
    float[] getControlPoints(){
      
      // make PVectors
      PVector ab = new PVector((Bx-Ax),(By-Ay)); //PVector from A to B
      PVector ba = new PVector((Ax-Bx),(Ay-By)); //PVector from B to A
      PVector aCP = PVector.mult(ab,-1); //PVector opposite of ab
      PVector bCP = PVector.mult(ba,-1); //PVector opposite of ba
      
      // make PVectors pointing to control points
      aCP.x =  aCP.mag() * cos(aCP.heading2D()+Strength);
      aCP.y =  aCP.mag() * sin(aCP.heading2D()+Strength);
      bCP.x =  bCP.mag() * cos(bCP.heading2D()-Strength);
      bCP.y =  bCP.mag() * sin(bCP.heading2D()-Strength);
      
      //return control points
      return new float[] {aCP.x+Ax, aCP.y+Ay, bCP.x+Bx, bCP.y+By};
    }
}


