//Iteration_04: Drawinglines between axes
// Is now able to robustly add new evenly spaced axes and plot model-points on them.

// -------- Mouse Over ----------------------
//   * mouse over for labeling axis
//   * mouse over for datapoint on each axis
//--------------------------------------------

//--------   Mouse Click ---------------------
//  - Right click on axis to set primary axis
//  - primary axis has the color interpolator
//--------------------------------------------

// -------  RightClick MouseDrag -------------
// - displays selection box for select a subset of models
// - (a) if box covers an axis perform easy selection
// - the selected models are highlighted (in white?) 
// - it outputs (to screen for now, and soon to file) the selected model indices
// 
// Problems
//   * very slow drawing because it is drawing N shapes every draw,
//    where N= number of models. SOLUTON: 
//      (Sol1) Only draw all model shapes when something happelns,
//        e.g., mouse click, mouseover on axis
//      (Sol2) Use screen capture to display plot as an image until you want to interact with it
//
//--------------------------------------------



// No shuffling features.

import processing.pdf.*;
boolean record = false;
boolean record_net = false;
int NumColumns;
int NumAxes;
int NumModels;
int widthW;  //window width
int heightW; //window height
int axisTop;
int axisBottom;
int axisHeight;
int nearestAxis;
ArrayList AxesNames = new ArrayList(); // all of the axes' names (default + new user axes)
float[][] allData; // all of the data in the datafile except axis labels
int[] ModelIndices; //Indices of each model, to match the indices in BP results directory
PaCoA myPlot;
int refAxisIdx;  // reference axis for color scaling
int[] blablabla;



boolean selectingPath = false;
String[] selectedPath = new String[2];
String userMessage = new String();
int selectionBoxStartX;  //corner of the selection box
int selectionBoxStartY;  //corner of the selection box
int selectionTop;        // top most y-value selected
int selectionBottom;     // bottom most y-value selected
int selectionLeft;       // left most x-value selected
int selectionRight;      // right most x-value selected
int firstIncludedAxis;
int mreleased;          // surrogate for mouseReleased
ArrayList<Integer> ModelsInBounds = new ArrayList();
Map<String, Axis> thisMap;
int[] AxesLocations;    // x-value locations of each axis

String refAxisLabel;  // the coloring reference axis label

PFrame f2;  //to be linked to netModels applet
secondApplet NetModelsWindow;  // new applet that operates in the new frame

void setup() {
  String[] lines = loadStrings("FinalData.txt");
  println(lines[0]);
  frameRate(10);
  Arrange_tsv_data(lines);
  widthW  = 1200;
  heightW = 700;
  axisTop=100;
  axisBottom = 550;
  axisHeight = (axisBottom-axisTop);
  
  size(widthW, heightW);
  background(0);
  myPlot = new PaCoA();  //Create new ParalleCoordinateAxes Plot
  refAxisLabel = (String) AxesNames.get(0);
  firstIncludedAxis = 0;

  PFrame f2 = new PFrame();
}

void draw() {
  if (record) {
    beginRecord(PDF,"parallel_coord_snapshot.pdf");
  }
  background(0);
  thisMap = myPlot.getMap();

  //Set Primary Axis (if first call to draw, use default refAxisIdx)
  Axis refAxis = thisMap.get(refAxisLabel);
  
  // Print model points. Start with data from first model
  int Xvalues[];    //x-locations of each of the axes
  int Yvalues[];
  Xvalues = new int[NumAxes];
  Yvalues = new int[NumAxes];
  AxesLocations = new int[NumAxes];


  strokeWeight(0.5);
  for (int j=1;j<=NumModels;j++) {
    for (int i=1;i<=NumAxes;i++) {
      Axis thisAxis = thisMap.get(AxesNames.get(i-1));
      thisAxis.DrawAxis();
      AxesLocations[i-1] = thisAxis.axisCenter;
      Xvalues[i-1] = thisAxis.axisCenter;
      Yvalues[i-1] = thisAxis.axisYvals[j-1];
      }
    

    if (ModelsInBounds.contains((j-1))) {
      stroke(255);
    } 
    else {
      color ModelColor = lerpColor(#FF0000, #0071BC, refAxis.axisDataPercents[j-1]);
      stroke(ModelColor);
    }

    noFill();
    strokeWeight(1);
    beginShape();
    for (int i=1;i<=NumAxes;i++) {
      vertex(Xvalues[i-1], Yvalues[i-1]);
    }
    endShape();
  }

  //Check mouseX for labeling the axes: hover
  for (int i=1;i<=NumAxes;i++) {
    if (abs(Xvalues[i-1]-mouseX)<10) {
      
      //textAlign(CENTER,CENTER);
      textSize(15);
      text((String)AxesNames.get(i-1), Xvalues[i-1], (axisTop-20));
      
      // if no axis is being moved
      nearestAxis = i;
      // otherwise do not change
      
      
      Axis thisAxis = thisMap.get(AxesNames.get(i-1));
      for (int j=1;j<=NumModels;j++) {
        if (abs(thisAxis.axisYvals[j-1]-mouseY)<2) {
          textSize(10);
          text(thisAxis.axisData[j-1], Xvalues[i-1], thisAxis.axisYvals[j-1]);
        }
      }
    }
  }

  // set primary axis
  if (mousePressed && (mouseButton==LEFT)) {
    for (int i=1;i<=NumAxes;i++) {
      if (abs(Xvalues[i-1]-mouseX)<10) {
        refAxisLabel = (String) AxesNames.get(i-1);
        //refAxisIdx=i; //default value.
      }
    }
  }

  // draw selection box 
  if (mousePressed && (mouseButton==RIGHT)) {
    stroke(150);
    noFill();
    rect(selectionBoxStartX, selectionBoxStartY, mouseX-selectionBoxStartX, mouseY-selectionBoxStartY);
    println(Xvalues);

    //check if selection box contains at least one axis. If so change color of y-values
    for (int j=1;j<=NumAxes;j++) {
      if ( ((Xvalues[j-1]-Math.min(selectionBoxStartX, mouseX))>0) && ((Xvalues[j-1]-Math.max(selectionBoxStartX, mouseX))<0)  ) {
        firstIncludedAxis = j;
      }
    }
  }

  if (mreleased==1) {
    Axis thisAxis = thisMap.get(AxesNames.get(firstIncludedAxis-1));
    ModelsInBounds.clear();

    ModelsInBounds = thisAxis.RetrieveModelsInBounds(selectionTop, selectionBottom);
    mreleased=0;
    int tempINT = (int) ModelsInBounds.get(0);
    println("Models In Bounds "+ModelsInBounds);
    NetModelsWindow.recieveCurrModels(ModelsInBounds);
    
  }
  
  stroke(240);
  rect(selectionLeft, selectionTop, (selectionRight-selectionLeft), (selectionBottom-selectionTop));
  
  if (record) {
    endRecord();
    record = false;
  }
  
}

public class PFrame extends Frame {
  public PFrame() {
    super("NetModels Applet");
    setBounds(100, 100, 750, 750);
    NetModelsWindow = new secondApplet();
    add(NetModelsWindow);
    NetModelsWindow.init();
    show();
    import processing.pdf.*;
  }
}

public class secondApplet extends PApplet {
  
  ArrayList<Integer> ModelsInclude = new ArrayList();
  int model_index;
  
  public void setup() {
    size(750, 750);
    loadNodes();
    loadModels();
    font = createFont("Helvetica", 10);
    textFont(font);  
    smooth();
    
  }
  
  public void recieveCurrModels(ArrayList<Integer> ModelsInBounds) {
    ModelsInclude.clear();
    ModelsInclude = ModelsInBounds;
    /**
    // this piece of code maps the integer of the ith model to the index
    int tempInt;
    int temp2;
    for (int i=0;i<ModelsInBounds.size();i++) {
      
      tempInt = ModelsInBounds.get(i);
      ModelsInclude.add(ModelIndices[tempInt]);
    }
    println("ModelsInclude = "+ModelsInclude);
    */
  }
  
  public void draw() {
    
    if (record_net) {
      println("begin Recording");
      beginRecord(PDF,"NetViewer.pdf");
    }

    background(0);
    textAlign(LEFT);
    text(userMessage,50,20);
    
    int modelEdgeCount = 0; //reset everytime we run through current models in draw
    

    // replace this line: for (int i = 0; i < currentModels.length; i++) {
    for (int i=0; i < ModelsInclude.size(); i++) {  
      
      
      int temp_mod_idx = ModelsInclude.get(i);
      int temp_mod_idx2 = ModelIndices[temp_mod_idx];
      int temp_indexOf = ImportModels.indexOf(("W_"+String.valueOf(temp_mod_idx2)+".txt"));
      String tempString = (String) ImportModels.get(temp_indexOf);      
      
      
      for (int j = 0; j < numberOfNodes; j++) {
        String jIndex = Integer.toString(j+1);
        String jNode = (String) mapIndexLabel.get(jIndex);
        if (jNode == null) {
          println ("cant find " + jIndex + " in mapIndexLabel hash");
          exit();
        }

        for (int k = 0; k < numberOfNodes; k++) {
          String kIndex = Integer.toString(k+1);
          String kNode = (String) mapIndexLabel.get(kIndex);
          if (kNode == null) {
            println ("cant find " + kIndex + " in mapIndexLabel hash");
            exit();
          }
          
          //model_index = ModelsInclude.get(i);
          float value = allModels[temp_indexOf][j][k];
          
          

          if (value > valueLowerBound || value < -valueLowerBound) {
            addEdge(jNode, kNode, value);        
            drawEdge(edges[modelEdgeCount]);
            modelEdgeCount++;
          }
        }
      }
    }
    

    for (int i = 0 ; i < nodeCount ; i++) {
      drawNode(nodes[i]);
    }
    
    if (record_net) {
      println("end Record");
      endRecord();
      record_net = false;
    }
    
  } //end draw of applet2

  public void drawEdge(Edge mycurredge) {
    //contents of Edge.draw()
    if (mycurredge.bendVal > 0 ) {
      stroke(lerpColor(colorZero, colorPos, mycurredge.colorVal, HSB));
    }
    else {  
      stroke(lerpColor(colorZero, colorNeg, mycurredge.colorVal, HSB));
    }
    strokeWeight(0.5);
    ControlPoints cp;
    cp = new ControlPoints(mycurredge.from.x, mycurredge.from.y, mycurredge.to.x, mycurredge.to.y, mycurredge.bendVal);
    float[] cpArray = cp.getControlPoints();
    noFill();
    curve(cpArray[0], cpArray[1], mycurredge.from.x, mycurredge.from.y, mycurredge.to.x, mycurredge.to.y, cpArray[2], cpArray[3]);
  }

  public void drawNode(Node mycurrnode) {
    fill(nodeColor);
    stroke(0);
    strokeWeight(0.5);

    //ellipse(x, y, count, count);
    ellipse(mycurrnode.x, mycurrnode.y, 20, 20);
    float w = textWidth(mycurrnode.label);

    fill(255);
    textAlign(CENTER, CENTER);
    text(mycurrnode.label, mycurrnode.x, mycurrnode.y);
  }
  
  public void keyPressed() {
    if (key=='q') {
      userMessage = "define a new feature for paths-between [source] and [target].  Please, Right-Mouse-Button select the source node.";
      selectingPath = true;
      selectedPath[0] = "";
      selectedPath[1] = "";
      
    }
    if (key=='r') {
      println("should take a picture");
      record_net = true;
    }
  }

  public void mousePressed() {
    float closest = 20;
    for (int i = 0; i < nodeCount; i++) {
      Node n = nodes[i];
      float d = dist(mouseX, mouseY, n.x, n.y);
      if (d < closest) {
        selection = n;
        closest = d;
      }
    }
    if (selection != null) {
      if (mouseButton == LEFT) {
        selection.fixed = true;
      } 
      else if (mouseButton == RIGHT) {
        userMessage = "the selected node = ";
        userMessage = userMessage.concat(selection.label);
        
        if (selectingPath == true) {
          if ( selectedPath[0].length()==0 ) {
            
            selectedPath[0] = selection.label;
            
          } 
          else if (selectedPath[0].length() > 0 && selectedPath[1].length()==0) {
            
            selectedPath[1] = selection.label;
            println("trying to run BP_FeatureExtract...");
            run_feature_selector();
            // THIS IS WHERE INTERFACE WITH BP_FEATURE EXTRACTOR SHOULD GO
            selectingPath = false;
            
          }
        }
        
      }
    }
      
  }

  public void mouseDragged() {
    if (selection != null) {
      if (mouseButton==LEFT) {
        selection.x = mouseX;
        selection.y = mouseY;
      }
    }
  }

  public void mouseReleased() {
    selection = null;
  }
}


void mouseDragged() {
  if (mouseButton==LEFT) {
    Axis axisToMove = thisMap.get(AxesNames.get(nearestAxis-1));
    boolean moving_right;
    
    //Check for re-ordering of axes
    axisToMove.axisCenter = mouseX;
    println("before cross: "+nearestAxis);
    if (mouseX > AxesLocations[nearestAxis]) {
      
      //1: switch axes names
      refAxisLabel = (String) AxesNames.get(nearestAxis-1);
      int formerLeft_idx = nearestAxis-1;
      int formerRight_idx = nearestAxis;
      String formerLeft = (String) AxesNames.get(nearestAxis-1);
      String formerRight = (String) AxesNames.get(nearestAxis);
      
      AxesNames.set(formerLeft_idx,formerRight);
      AxesNames.set(formerRight_idx,formerLeft);
      
      moving_right = true;
      
      println("time to switch right");
      
    }
    else if (mouseX < AxesLocations[nearestAxis-2]) {
      println("time to switch left");
    }
    
    
  }
}

void keyPressed() {
  if (key=='c') { 
    record = true;
  }
  if (key=='d') {
    println("right before remove: nearestAxis = "+String.valueOf(nearestAxis));
    
    thisMap.remove(AxesNames.get(nearestAxis-1));
    AxesNames.remove(nearestAxis-1);
    NumAxes = NumAxes-1;
    if (nearestAxis>=2) {
      refAxisLabel = (String) AxesNames.get(nearestAxis-1);
      //refAxisIdx = nearestAxis-1;
    }
  }
}

void mousePressed() {
  if (mouseButton==RIGHT) {
    selectionBoxStartX = mouseX;
    selectionBoxStartY = mouseY;
  }
}

void mouseReleased() {

  if (mouseButton==RIGHT) {
    mreleased = 1;
    selectionTop = Math.min(selectionBoxStartY, mouseY);
    selectionBottom = Math.max(selectionBoxStartY, mouseY);
    selectionLeft = Math.min(selectionBoxStartX, mouseX);
    selectionRight = Math.max(selectionBoxStartX, mouseX);

    //print coordinates of selection box
    println("Top = "+selectionTop);
    println("Bottom = "+selectionBottom);
    println("Left = "+selectionLeft);
    println("Right = "+selectionRight);

    //check if an axis is selected
    if (firstIncludedAxis>0) {
      println("we've got a winner and its number is "+firstIncludedAxis);
    }
  }
}

// retrieve all the data from a tsv file
void Arrange_tsv_data(String[] lines) {
  NumModels = (lines.length-1);
  ModelIndices = new int[NumModels];

  
  
  
  for (int i=0;i<lines.length;i++) {
    //get column headers from the first line
    //The first column must always be the model-index
    
    if (i==0) {
      String[] pieces = lines[0].split("\t");
      NumColumns = pieces.length;
      NumAxes = NumColumns-1;

      allData = new float[NumModels][NumAxes];

      for (int j=0;j<NumAxes;j++) {
        AxesNames.add(pieces[j+1].trim());
      }
      println(AxesNames);
    } 
    else {
      
      String[] pieces = lines[i].split("\t");
      ModelIndices[i-1] = int(pieces[1]);
      for (int j=0;j<NumAxes;j++) {
        
        allData[i-1][j] = float(pieces[j+1]);
      }
    }
  }
}


class PaCoA {
  //a class for each plot, each with one or more axis

  //Variables
  int maxLeft;
  int maxRight;
  int[] axesLocations;
  int distBetweenAxes;
  Map myMap = new HashMap<String, Axis>();

  PaCoA() {
    maxLeft  = 10;
    maxRight = widthW-100;
    axesLocations = new int[NumAxes]; //integer array to store the locations of each axis' x-location
    distBetweenAxes = ((maxRight-maxLeft)/(NumAxes-1));


    for (int i=0;i<NumAxes;i++) {
      axesLocations[i] = maxLeft+(i*distBetweenAxes);
      Axis myAxis = new Axis(i, axesLocations[i]);
      myMap.put(AxesNames.get(i),myAxis);
      myAxis.DrawAxis();
    }
  }

  public Map<String, Axis> getMap() {
    return myMap;
  }
}



class Axis {
  // a class for each coordinate-axis
  //Variables: name,max,min,visible,color,order,x_location
  String axisName;
  int axisCenter;
  int[] axisYvals;
  float[] axisData;
  float[] axisDataPercents;
  float DataMax;
  float DataMin;

  //Methods  : changeColor,changeOrder,makeVisible,changeLocation

    //default constructor

  //Axis Properties: axis*: Name,Center,Data
  Axis(int dataCol, int xloc) {
    axisName = (String) AxesNames.get(dataCol);
    axisCenter = xloc;
    axisData = new float[NumModels];
    axisDataPercents = new float[NumModels];

    for (int j=0;j<NumModels;j++) {
      axisData[j] = allData[j][dataCol];
    }

    //Now Normalize data
    DataMax = max(axisData);
    DataMin = min(axisData);
    axisYvals = new int[NumModels];
    for (int j=0;j<NumModels;j++) {
      axisDataPercents[j] = norm(axisData[j], DataMin, DataMax);
      axisYvals[j]= int(axisHeight*(1-axisDataPercents[j]));
      axisYvals[j] = axisTop+axisYvals[j];
      println(axisYvals[j]);
    }
  }

  void DrawAxis() {
    stroke(255);
    strokeWeight(1);
    line(axisCenter, axisTop, axisCenter, axisBottom);
  }



  //Retrieve models that fall within the selection box
  public ArrayList RetrieveModelsInBounds(int LowerBound, int UpperBound) {
    ArrayList<Integer> TempAL = new ArrayList();
    // LowerBound = the y-value corresponding to the TOP of the selection box
    // UpperBound = the y-value corresponding to the BOTTOM of the selection box

    println("LowerBound = "+String.valueOf(LowerBound));
    println("UpperBound = "+String.valueOf(UpperBound));

    for (int i=0;i<NumModels;i++) {
      if ((axisYvals[i]<UpperBound) && (axisYvals[i]>LowerBound)) {
        TempAL.add(i);
        //println(String.valueOf(i)+"->"+String.valueOf(axisYvals[i])+"->"+String.valueOf(axisData[i]));
      }
    }

    //println(TempAL);


    return TempAL;
  }
}    

