

//
// TO DO:
//
// * if no xy.txt node position data defined then make random layout of nodes
// * handle node letter case, now all names are made lower case, because the hashes seem to only operate lower case
// * if there is discontinuous file names, the file ID will be changed to have running numbers, need to keep track of this so actual model number refers to actual file number
// * better way of defining color and bend than just mapping using maxW ?
//
//
//
//




//
//change these variables according to the number of nodes and models
//
static final int numberOfModels = 1000;
static final int numberOfNodes = 28;
static final float valueLowerBound = 0.4; //remove interactions lower than +/- valueLowerBound
static final ArrayList ImportModels = new ArrayList();
//


//
//fixed variables
//
static final float maxCurve = PI/4; static final float minCurve = PI/16; //max and min of curvatures (radians)
static final color nodeColor   = 150;
static final color selectColor = #FF3030;
static final color fixedColor  = #FF8080;
static final color edgeColor   = 209;
static final color colorPos = #ff0000;
static final color colorZero = #00ff00;
static final color colorNeg = #0000ff;
//








//
//declare variables
//
int nodeCount;
Node[] nodes = new Node[100]; // need to change this max?
HashMap nodeTable = new HashMap(); //hash table expands dynamically as edges are added
HashMap nodeInitialX = new HashMap(); //has table with initial x,y coordinates read in (has to be in the order of nodes in W matrix and same length)
HashMap nodeInitialY = new HashMap();
HashMap mapIndexLabel = new HashMap(); //maps between node names in x,y coordiante file and node number in W matrix

float[][][] allModels = new float[numberOfModels][numberOfNodes][numberOfNodes]; //storing all models in 3d array

int[] currentModels = {1, 5, 9, 15, 30, 60, 2, 3,  4, 10}; //running through this array of models, which is to be linked to parallel coordinates


float maxPosStrength = 0; float maxNegStrength = 0; //max of postive and negative interaction strengths in all models
int edgeCount; //not used anymore since using:  modelEdgeCount in draw, however this we might need to change
Edge[] edges = new Edge[500];
//



import processing.pdf.*;
PFont font;

/**  REMOVE THIS BECAUSE IT CONFLICTS WITH THE CALL IN THE MAIN APP



void setup() {
  size(750, 750);
  //println(PFont.list());  
  loadNodes();
  loadModels();
 // showModels(); //moved to draw
  //println("total edges: " + edgeCount);
  font = createFont("Helvetica", 10);
  textFont(font);  
  smooth();
}

*/



void loadNodes() {
  String[] lines = loadStrings("xy.txt");
  for (int i = 0; i < lines.length; i++) {
      String[] nodes = splitTokens(lines[i], "\t");
      String label = nodes[0];
      label = label.toLowerCase();
      float x = new Float(nodes[1]);
      float y = new Float(nodes[2]);
      nodeInitialX.put(label,x);
      nodeInitialY.put(label,y);
      
      String nodeIndex = Integer.toString(i+1);
      mapIndexLabel.put(nodeIndex,label);
  }
  
  
}

void loadModels() {  //read all model files
  int fileCount = 0;
  for (int i = 0; i < numberOfModels; i++){
    String modelNumber = Integer.toString(i+1);
    String myFile = ("W_" + modelNumber + ".txt");

    File f = new File(dataPath(myFile));
    if(f.exists()){
      ImportModels.add(fileCount,myFile);
      String[] lines = loadStrings(myFile);

      for (int j = 0; j < lines.length; j++){ //could be fixed by numberOfNodes
        String[] valueStr = splitTokens(lines[j], " ");
        for (int k = 0; k < valueStr.length; k++){ //could be fixed by numberOfNodes
        
          float value = Float.parseFloat(valueStr[k]);     
          allModels[fileCount][j][k] = value;  //if there is discontinuous file names, the file ID will be changed to have running numbers, need to keep track of this so actual model number refers to actual file number
          if(value > maxPosStrength){
            maxPosStrength = value;
          }
          if(value < maxNegStrength){
            maxNegStrength = value;
          }
        }//end for k
      }//end for j
      fileCount++;
    }
    else{
      println ("### warning: " + myFile + " does not exist, i.e. model number will no longer match file name");
    }
  }//end for i
  if(maxPosStrength == 0 && maxNegStrength == 0){
    println ("### did not find any interactions");
    exit();
  }
  println("maxPosStrength: " + maxPosStrength + "   maxNegStrength: " + maxNegStrength);
}




void addEdge(String fromLabel, String toLabel, float strength) {

  Node from = findNode(fromLabel);
  Node to = findNode(toLabel);
  from.increment();
  to.increment();
  
  for (int i = 0; i < edgeCount; i++) {
    if (edges[i].from == from && edges[i].to == to) {
      edges[i].increment();
      //return;
    }
  }
  float bendVal = 0; 
  float colorVal = 0;
   bendVal = map(strength, 0, max(maxPosStrength, abs(maxNegStrength)), minCurve, maxCurve);
   if(strength > 0){
       colorVal = norm(strength, 0, maxPosStrength);
    }
    else{
      colorVal = norm(abs(strength), 0, abs(maxNegStrength));
    }
 
  Edge e = new Edge(from, to, bendVal, colorVal);
  e.increment();
  if (edgeCount == edges.length) {
    edges = (Edge[]) expand(edges);
  }
  edges[edgeCount++] = e;
}


Node findNode(String label) {
  label = label.toLowerCase();
  Node n = (Node) nodeTable.get(label);
  if (n == null) {
    return addNode(label);
  }
  return n;
}


Node addNode(String label) {
  Node n = new Node(label);  
  if (nodeCount == nodes.length) {
    nodes = (Node[]) expand(nodes);
  }
  nodeTable.put(label, n);
  //println ("adding node " + label + " at n = " + n);
  nodes[nodeCount++] = n;  
  return n;
}


/**


void draw() {
  if (record) {
    beginRecord(PDF, "output.pdf");
  }
  
  background(0);
  int modelEdgeCount = 0; //reset everytime we run through current models in draw
 
  for (int i = 0; i < currentModels.length; i++){
    for (int j = 0; j < numberOfNodes; j++){
      String jIndex = Integer.toString(j+1);
      String jNode = (String) mapIndexLabel.get(jIndex);
      if (jNode == null){
        println ("cant find " + jIndex + " in mapIndexLabel hash");
        exit();
      }
      for (int k = 0; k < numberOfNodes; k++){
        String kIndex = Integer.toString(k+1);
        String kNode = (String) mapIndexLabel.get(kIndex);
        if (jNode == null){
          println ("cant find " + kIndex + " in mapIndexLabel hash");
          exit();
        }
        float value = allModels[currentModels[i]][j][k];

        if (value > valueLowerBound || value < -valueLowerBound){
            addEdge(jNode,kNode,value);        
            edges[modelEdgeCount].draw();
            modelEdgeCount++;
        }
      }
    }
  }
  
  */
  
  /**

  //println(modelEdgeCount);

  for (int i = 0 ; i < edgeCount ; i++) {
   // edges[i].relax();
  }
  for (int i = 0; i < nodeCount; i++) {
    // nodes[i].relax();
  }
  for (int i = 0; i < nodeCount; i++) {
   //  nodes[i].update();
  }
  for (int i = 0 ; i < edgeCount ; i++) {
   // edges[i].draw();
   // println(i);
  }
  for (int i = 0 ; i < nodeCount ; i++) {
    nodes[i].draw();
  }
  
  if (record) {
    endRecord();
    record = false;
  }
}


boolean record;

void keyPressed() {
  if (key == 'r') {
    record = true;
  }
}

*/
Node selection; 
/**

void mousePressed() {
  // Ignore anything greater than this distance
  float closest = 20;
  for (int i = 0; i < nodeCount; i++) {
    Node n = nodes[i];
    float d = dist(mouseX, mouseY, n.x, n.y);
    if (d < closest) {
      selection = n;
      closest = d;
    }
  }
  if (selection != null) {
    if (mouseButton == LEFT) {
      selection.fixed = true;
    } else if (mouseButton == RIGHT) {
      selection.fixed = false;
    }
  }
}


void mouseDragged() {
  if (selection != null) {
    selection.x = mouseX;
    selection.y = mouseY;
  }
}


void mouseReleased() {
  selection = null;
}

*/

